program uslov;
const MENO_SUBORU = 'uslova.txt';

type smernik = ^struct;
     struct  =  record
                  slovo : string;
                  pocet : word;
                  sused : smernik;
                end;

var zaciatok : smernik;
    subor    : text;


procedure zaradslovo(slovo : string);
var clen : smernik;
    bulo : boolean;
begin
  clen:=zaciatok;
  bulo:=false;
  while clen<>nil do begin (* test na vyskyt slova  *)
    if slovo=clen^.slovo then begin
      clen^.pocet:=clen^.pocet+1;
      bulo:=true;
    end;
    clen:=clen^.sused;
  end;
  if bulo then exit; (* ak uz je v zozname tak koniec procedury *)

  new(clen);
  clen^.slovo:=slovo;
  clen^.pocet:=1;
  clen^.sused:=zaciatok;
  zaciatok:=clen;
    
end;

procedure citajsubor(var subor : text);
var slovo : string;
begin
  while not eof(subor) do begin
    readln(subor, slovo);
    zaradslovo(slovo);
  end;
  close(subor);
end;

procedure vypisnetriedeny;
var clen : smernik;
begin
  assign(subor, ''); rewrite(subor);
  clen:=zaciatok;
  while clen<>nil do begin
    writeln(subor, clen^.slovo, ' [', clen^.pocet, ']');
    clen:=clen^.sused;
  end;
end;

procedure usporiadanie;
var clen : smernik;
    oldo : smernik; (* predchadzajuci clen *)
    temp : smernik; (* bublacka *)
    uznetreba : boolean;
begin
    clen:=zaciatok;
    oldo:=zaciatok;
    if clen^.sused<>nil then clen:=clen^.sused
    else exit;
  repeat
    uznetreba:=true;
    while clen<>nil do begin
      if oldo^.slovo>clen^.slovo then begin
        temp^.slovo:=oldo^.slovo;
        temp^.pocet:=oldo^.pocet;
        oldo^.slovo:=clen^.slovo;
        oldo^.pocet:=clen^.pocet;
        clen^.slovo:=temp^.slovo;
        clen^.pocet:=temp^.pocet;
        uznetreba:=false;
      end;
      oldo:=clen;
      clen:=clen^.sused;
    end;
    clen:=zaciatok^.sused;
    oldo:=zaciatok;
  until uznetreba;
end;

begin
  zaciatok:=nil;
  {$I-}
    assign(subor, MENO_SUBORU);
    reset(subor);
  {$I+}
  if ioresult<>0 then begin
    writeln('subor ', MENO_SUBORU, ' neexistuje');
    halt(1);
  end;

  citajsubor(subor);

  writeln('Neusporiadany vypis slov zo suboru ', MENO_SUBORU);
  vypisnetriedeny;

  writeln('Prajem si Enter!'); readln; 
  writeln('Usporiadany vypis slov zo suboru ', MENO_SUBORU);
  usporiadanie;  
  vypisnetriedeny; (* uz by mal byt usporiadany *)
  writeln(subor,'Opat si prajem Enter!'); readln;

end.